src/api/urls.py
# -*- coding: utf-8 -*-
from django.conf.urls import patterns, url
from django.views.decorators.csrf import csrf_exempt
from piston.authentication import OAuthAuthentication, oauth_access_token
from piston.resource import Resource

from api import handlers
from api.helpers import CsrfExemptResource

auth = OAuthAuthentication(realm="Edukacja Medialna")

lesson_list_resource = CsrfExemptResource(handler=handlers.LessonsHandler, authentication=auth)
lesson_resource = Resource(handler=handlers.LessonDetailHandler)

urlpatterns = patterns(
    'piston.authentication',
    url(r'^oauth/request_token/$', 'oauth_request_token'),
    url(r'^oauth/authorize/$', 'oauth_user_auth'),
    url(r'^oauth/access_token/$', csrf_exempt(oauth_access_token)),
)

urlpatterns += patterns(
    '',
    # url(r'^$', TemplateView.as_view(template_name='api/main.html'), name='api'),

    # objects details
    url(r'^lessons/(?P<lesson>[a-z0-9-]+)/$', lesson_resource, name="api_lesson"),

    # lessons
    url(r'^lessons/$', lesson_list_resource, name='api_lesson_list'),
)

src/forum/urls.py
# -*- coding: utf-8 -*-
from django.conf.urls import patterns, url
from haystack.query import SearchQuerySet
from haystack.views import SearchView, search_view_factory
from haystack.forms import SearchForm
from pybb.models import Post

from .views import AddPostView, EditPostView


urlpatterns = patterns(
    '',
    url(r'^forum/(?P<forum_id>\d+)/topic/add/$', AddPostView.as_view()),
    url(r'^post/(?P<pk>\d+)/edit/$', EditPostView.as_view()),
)

PostsSearchQuerySet = SearchQuerySet().models(Post).highlight()

urlpatterns += patterns(
    'haystack.views',
    url(r'^szukaj/$', search_view_factory(
        view_class=SearchView,
        template='forum/search_results.html',
        searchqueryset=PostsSearchQuerySet,
        form_class=SearchForm
    ), name='forum_search'))

src/forum/models.py
# -*- coding: utf-8 -*-
from django.db import models

import pybb.models

from catalogue.models import Lesson


class Topic(models.Model):
    pybb_topic = models.OneToOneField(pybb.models.Topic, primary_key=True, related_name='edumed_topic')
    lesson = models.ForeignKey(Lesson, null=True, blank=True, related_name='forum_topics')

src/forum/forms.py
# -*- coding: utf-8 -*-
from django import forms
from django.forms.models import ModelChoiceIterator
from django.utils.translation import ugettext as _
import pybb.forms

from catalogue.models import Lesson


class GroupedModelChoiceIterator(ModelChoiceIterator):
    def __init__(self, field):
        super(GroupedModelChoiceIterator, self).__init__(field)
        self.queryset = self.field.grouping_model.objects
        self.items_queryset = self.field.queryset
    
    def choice(self, obj):
        items_query = self.items_queryset.filter(**{self.field.grouping_fk_field: obj})
        items = [super(GroupedModelChoiceIterator, self).choice(item) for item in items_query.all()]
        return unicode(obj), items


class GroupedModelChoiceField(forms.ModelChoiceField):
    
    def __init__(self, queryset, grouping_fk_field, **kwargs):
        self.grouping_fk_field = grouping_fk_field
        self.grouping_model = queryset.model._meta.get_field(grouping_fk_field).rel.to
        super(GroupedModelChoiceField, self).__init__(queryset, **kwargs)

    def _get_choices(self):
        toret = super(GroupedModelChoiceField, self)._get_choices()
        if isinstance(toret, ModelChoiceIterator):
            toret = GroupedModelChoiceIterator(self)
        return toret

    choices = property(_get_choices, forms.ModelChoiceField.choices.fset)


class PostForm(pybb.forms.PostForm):
    lesson = GroupedModelChoiceField(
        label=_('Related lesson'), queryset=Lesson.objects.all(),
        grouping_fk_field='section', required=False)

src/forum/views.py
# -*- coding: utf-8 -*-
from django.core.exceptions import ObjectDoesNotExist
import pybb.views
import pybb.forms

from .forms import PostForm
from .models import Topic


class PostEditMixin(pybb.views.PostEditMixin):

    def get_form_class(self):
        toret = super(PostEditMixin, self).get_form_class()
        if issubclass(toret, pybb.forms.PostForm):
            toret = PostForm
        return toret

    def form_valid(self, form):
        toret = super(PostEditMixin, self).form_valid(form)

        pybb_post = self.object
        pybb_topic = pybb_post.topic
        topic, topic_created = Topic.objects.get_or_create(pybb_topic=pybb_topic)

        if pybb_post == pybb_topic.head:
            topic.lesson = form.cleaned_data['lesson']
            topic.save()

        return toret


class AddPostView(PostEditMixin, pybb.views.AddPostView):
    def get_context_data(self, **kwargs):
        ctx = super(AddPostView, self).get_context_data(**kwargs)
        ctx['lesson_editable'] = self._creates_new_topic()
        return ctx

    def _creates_new_topic(self):
        return self.forum is not None


class EditPostView(PostEditMixin, pybb.views.EditPostView):
    def get_context_data(self, **kwargs):
        ctx = super(EditPostView, self).get_context_data(**kwargs)
        ctx['lesson_editable'] = self._edits_topics_head()
        return ctx

    def _edits_topics_head(self):
        return self.object == self.object.topic.head

    def get_form_kwargs(self):
        kwargs = super(EditPostView, self).get_form_kwargs()
        try:
            lesson = self.object.topic.edumed_topic.lesson
        except ObjectDoesNotExist:
            lesson = None
        kwargs['initial']['lesson'] = lesson
        return kwargs

src/forum/templates/pybb/category.html
{% load url from future %}
{% load i18n pybb_tags %}

{% if category.forums_accessed|pybb_forum_unread:user|length > 0 %}
<div class='category'>
    <table class="table category-table">
        <thead>
            <tr class="forum-row head-row">
                <th class="forum-name">
                    {% trans "Forum" %}
                </th>
                <th class="forum-topic-count">
                    {% trans "Topics" %}
                </th>
                <th class="forum-post-count">
                    {% trans "Posts" %}
                </th>
                <th class="forum-last-post">
                    {% trans "Last posts" %}
                </th>
            </tr>
        </thead>
        <tbody>
        {% for forum in category.forums_accessed|pybb_forum_unread:user %}
            <tr class="forum-row">
                <td class="forum-name {% if forum.unread %} forum-unread{% endif %}">
                    <div class="state-indicator"></div>
                    <a href="{{ forum.get_absolute_url }}">{{ forum.name }}</a> {% if forum.hidden %}[{% trans "Hidden" %}]{% endif %}
                    <div class="forum-description">
                        {{ forum.description|safe }}
                    </div>
                </td>
                <td class="forum-topic-count">
                    {{ forum.topic_count }}
                </td>
                <td class="forum-post-count">
                    {{ forum.post_count }}
                </td>
                <td class="forum-last-post">
                    {% include "pybb/forum_last_update_info.html" %}
                </td>
            </tr>
        {% endfor %}
        </tbody>
    </table>
</div>
{% endif %}

src/forum/templates/pybb/forum_last_update_info.html
{% load humanize %}
{% if forum.updated %}
    {{ forum.last_post.user }}
    {{ forum.updated|naturaltime }}
{% endif %}

src/forum/templates/pybb/post_form.html
{% load url from future %}
{% load i18n pybb_tags %}
<form class="post-form" action="
    {% if forum %}
        {% url 'pybb:add_topic' forum.pk %}
    {% else %}
        {% if topic %}
            {% url 'pybb:add_post' topic.pk %}
        {% else %}
            {% url 'pybb:edit_post' pk=object.pk %}
        {% endif %}
    {% endif %}" method="post" enctype="multipart/form-data">
  {% csrf_token %}
  <fieldset>
    {% include "pybb/form_errors.html" %}
    {% if form.name %} {% include "pybb/form_field.html" with field=form.name %} {% endif %}

    {% if lesson_editable %}
        {% include "pybb/form_field.html" with field=form.lesson %}
    {% endif %}

    {% if form.login %} {% include "pybb/form_field.html" with field=form.login %}  {% endif %}
    {% if form.body %} {% include "pybb/form_field.html" with field=form.body %}  {% endif %}
    <div id='emoticons'>
      {% for smile, url in form.available_smiles.items %}
        <a href='#' title='{{ smile|safe }}'><img src='{{ STATIC_URL }}{{ form.smiles_prefix }}{{ url }}'></a>
      {% endfor %}
    </div>

    {% if form.poll_type and request.user.is_superuser %}
      {% include "pybb/poll_edit_form.html" %}
    {% endif %}
    {% include "pybb/attachments_formset.html" %}
    <p class="submit">{% include "pybb/_button_submit.html" %}</p>
  </fieldset>
</form>

src/forum/templates/pybb/topic.html
{% extends 'pybb/base.html' %}

{% load url from future %}

{% load pybb_tags i18n %}

{% block title %}{{ topic }}{% endblock %}

{% block extra_script %}
    {{ block.super }}
    {% include "pybb/_markitup.html" %}
    <script type="text/javascript" src="{{ STATIC_URL }}pybb/js/jquery.formset.min.js"></script>
{% endblock %}

{% block breadcrumb %}
    {% with object=topic %}
        {% include "pybb/breadcrumb.html" %}
    {% endwith %}
{% endblock %}

{% block content %}
    <div class="topic">
        <h1>{{ topic.name }}</h1>
        
        {% include 'forum/related_lesson_info.html' with lesson=topic.edumed_topic.lesson %}
        
        {% with _('Posts') as label %}
            {% include "pybb/pagination.html" %}
        {% endwith %}

        {% if topic.poll_type %}
            {% include 'pybb/poll.html' %}
        {% endif %}

        <div class="posts">
            {% if first_post %}{% ifnotequal first_post post_list.0 %}
                {% with first_post as post %}
                    <li class="first_post">{% include "pybb/post_template.html" %}</li>
                {% endwith %}
            {% endifnotequal %}{% endif %}
            {% for post in post_list %}
                {% cycle 'odd' 'even' as rowcolors silent %}
                {% include "pybb/post_template.html" %}
            {% endfor %}
        </div>
        <div>&nbsp;</div>
        {% with _('Posts') as label %}
            {% include "pybb/pagination.html" %}
        {% endwith %}

        {% if user.is_authenticated %}
            <div class="controls">
                {% if user.is_moderator %}
                    {% if topic.sticky %}
                        <a href="{% url 'pybb:unstick_topic' topic.id %}">{% trans "Unstick topic" %}</a> /
                    {% else %}
                        <a href="{% url 'pybb:stick_topic' topic.id %}">{% trans "Stick topic" %}</a> /
                    {% endif %}

                    {% if topic.closed %}
                        <a href="{% url 'pybb:open_topic' topic.id %}">{% trans "Open topic" %}</a> /
                    {% else %}
                        <a href="{% url 'pybb:close_topic' topic.id %}">{% trans "Close topic" %}</a> /
                    {% endif %}
                    {% if perms.pybb.change_topic and user.is_staff %}
                        <a href="{% url 'admin:pybb_topic_change' topic.id %}">{% trans 'Admin' %}</a> /
                    {% endif %}
                    {% comment %}
            <a href="{% url 'pybb:merge_topics' %}?topic={{ topic.id }}">{% trans 'Merge topics' %}</a> /
            {% endcomment %}
                {% endif %}

                {% if user.is_subscribed %}
                    <a href="{% url 'pybb:delete_subscription' topic.id %}?from_topic">{% trans "Unsubscribe" %}</a>
                {% else %}
                    <a href="{% url 'pybb:add_subscription' topic.id %}">{% trans "Subscribe" %}</a>
                {% endif %}
            </div>
        {% endif %}

        {% if user.is_authenticated or PYBB_ENABLE_ANONYMOUS_POST %}
            {% pybb_get_profile user=user as user_profile %}

            {% if not user_profile.is_banned %}
                {% if not topic.closed %}
                    {% include "pybb/post_form.html" %}
                {% endif %}
            {% endif %}
        {% else %}
            {% include 'pybb/_need_to_login_message.html' %}
        {% endif %}

        {% if user.is_staff %}
            <div class="subscriber-list">
                {% trans "Subscribers" %}:
                {% for subscriber in topic.subscribers.all %}
                    <a href="{% url 'pybb:user' subscriber.username %}">{{ subscriber.username }}</a>,
                {% endfor %}
            </div>
        {% endif %}
    </div>
{% endblock %}

src/forum/templates/pybb/topic_last_message_info.html
{% load humanize %}
{% if topic.updated %}
    {{ topic.last_post.user }}
    {{ topic.updated|naturaltime }}
    
{% endif %}